<?php
// This script receives the uploaded file, down scales and saves it
// into current directory.  Then it redirects the browser
// to the editing page specifying the filename in the URL.

error_reporting (E_ALL);

$this_dir = realpath('./');
if (!is_writable($this_dir)) die('Not enough permission to write in this directory.');

if (isset($_FILES['user_file']['tmp_name'])) {
    // check for upload errors
    $error = $_FILES['user_file']['error'];    
    if ($error==UPLOAD_ERR_INI_SIZE) die('The uploaded file is too large.');
    else if ($error > 0) die("Error receiving the uploaded file: $error");

    $temp_name = $_FILES['user_file']['tmp_name'];

    // check image format and set file extension accordingly
    $check = getimagesize($temp_name);
    switch($check[2]) {
	case 1: $ext = 'gif'; break;
	case 2: $ext = 'jpeg'; break;
	case 3: $ext = 'png'; break;
	default: die('Expected a JPEG or PNG or GIF image');
    }
    $width  = $check[0];
    $height = $check[1];

    $filename = (time()-1431728650).".$ext"; // generate the file name
    $filepath = "$this_dir/$filename";

    // try to move the uploaded file to current directory.
    if (!move_uploaded_file($temp_name,$filepath))
	die("Failed to move the uploaded file from $temp_name to $filepath\n");

    $max_size = 1024; // if either side of the image is greater than 1024 scale it down
    if ($width > $max_size || $height > $max_size) {
	switch($ext) { // load
	    case 'gif' : $image = imagecreatefromgif($filepath);  break;
	    case 'jpeg': $image = imagecreatefromjpeg($filepath); break;
	    case 'png' : $image = imagecreatefrompng($filepath);  break;
	}
	if ($image) { // scale down
	    $scale = min( $max_size/$width, $max_size/$height );
	    $w = round($width*$scale);
	    $h = round($height*$scale);
	    $resized_image = imagecreatetruecolor($w,$h);
	    if ($ext=='png') { // necessary for PNG with transparency
		imagealphablending($resized_image, false);
		imagesavealpha($resized_image, true);
	    }
	    imagecopyresampled($resized_image, $image, 0,0, 0,0, $w, $h, $width, $height);
	    imagedestroy($image);
	    switch($ext) { // save
		case 'gif' : imagegif($resized_image,$filepath); break;
		case 'jpeg': imagejpeg($resized_image,$filepath,75); break;
		case 'png' : imagepng($resized_image,$filepath); break;
	    }
	    imagedestroy($resized_image);
	}
    }
    // go to the editing page
    redirectTo("index.html?image=$filename");
}
else
    die('user_file is not found in the request');

function redirectTo($page) {
    $schema = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') ? 'https' : 'http';
    $host = $_SERVER['HTTP_HOST'];
    $port = $_SERVER['SERVER_PORT'];
    $dir  = dirname($_SERVER['PHP_SELF']);
    if (substr($dir,0,1)=='/' && strlen($dir) > 1) $dir = substr($dir,1,strlen($dir)-1);
    header("Location: $schema://$host:$port/$dir/$page");    
}
?>